package com.gz.service.system;

import cn.hutool.core.lang.tree.Tree;
import com.github.pagehelper.PageInfo;
import com.gz.controller.system.DictController;
import com.gz.core.exception.BusinessException;
import com.gz.dto.system.DictDTO;
import com.gz.dto.system.gdndDTO;
import com.gz.vo.system.DictVO;

import java.util.List;
import java.util.Map;

public interface DictService {

    /**
     * @description 增
     * @author LiuChangLan
     * @since 2020/9/4 14:46
     */
    Integer insert(DictDTO dictDTO) throws BusinessException;

    /**
     * @description 删
     * @author LiuChangLan
     * @since 2020/9/4 14:46
     */
    Integer delete(Integer id);

    /**
     * @description 改
     * @author LiuChangLan
     * @since 2020/9/4 14:46
     */
    Integer update(DictDTO dictDTO) throws BusinessException;

    /**
     * @description 查(分页)
     * @author LiuChangLan
     * @since 2020/9/4 14:46
     */
    PageInfo<DictDTO> selectByPage(DictVO dictVO);

    /**
     * @description 根据主键查询
     * @author LiuChangLan
     * @since 2020/9/4 16:35
     */
    DictDTO selectByPrimaryKey(Integer id);

    /**
     * @description 查
     * @author LiuChangLan
     * @since 2020/9/7 10:25
     */
    List<DictDTO> select();

    /**
     * @description 获取字典树
     * @author LiuChangLan
     * @since 2020/9/7 14:46
     */
    List<Tree<String>> getDictTree();

    /**
     * @description 根据code查询所有选项
     * @author LiuChangLan
     * @since 2020/9/7 16:57
     */
    List<DictDTO> selectDictByCode(String code);


    /**
     * 获取字典Code
     * @param chineseName 中文
     * @return 字典Code
     */
    String getDictCode(String chineseName);

    /**
     * @description 根据code获取名称
     * @author LiuChangLan
     * @since 2020/10/28 14:16
     */
    String getDictName(String code);

    /**
     * @description 根据code查询单个字典
     * @author LiuChangLan
     * @since 2021/2/24 15:52
     */
    DictDTO selectByCode(String code);

    /**
     * @description 查询所有归档年度
     * @author zhanghai
     * @since 2021/9/11
     */
    List<gdndDTO> selectGdnd();

    /**
     * @description 查询密集权限
     * @author LiuChangLan
     * @since 2021/3/8 17:22
     */
    List<Map> selectMiJiRole(Integer roleId);

    /**
     * @description 部门权限
     * @author LiuChangLan
     * @since 2021/3/8 17:22
     */
    Integer selectDeptQx(Integer roleId);
}
